%[img, map, alpha] = imread('swan-256.jpg');
[img, map, alpha] = imread('swan-512.jpg');
%[img, map, alpha] = imread('swan-1024.jpg');

R = double( img(:,:,1) ) / 255;
G = double( img(:,:,2) ) / 255;
B = double( img(:,:,3) ) / 255;

% a grayscale image, http://en.wikipedia.org/wiki/YUV
u = 0.299*R + 0.587*G + 0.144*B;

%% Add noise
noisetype = 1;
if noisetype == 0
  % none!
elseif noisetype == 1
  % additive noise added to every pixel, normally distributed, mean 0,
  % stdev 0.1
  noise = 0 + 0.1*randn(size(u));
  u = u + noise;
elseif noisetype == 2
  % salt-and-pepper
  noise = 2*rand(size(u)) - 1;
  % select 5% of pixels
  IJ = abs(noise) > 0.95;
  u(IJ) = rand(size(u(IJ)));
end


%% Displaying an image
figure(1); clf;
imagesc(u);
axis equal; axis tight;
colormap(gray);
colorbar


%% Grid
% the order is not an error here!
[Ny,Nx] = size(u)

